#include <codeur.h>
//*****************************
// ***** Les variables ********
// ****************************
encoder codeur1 = encoder(bidirdouble + speedcompute, 2, 4); // compteur sur broche 2 et 4 (voie A et voie B seule A est interruptible)
encoder codeur2 = encoder(bidirdouble , 3, 5); // compteur sur broche 3 et 5 (voie A et voie B seule A est interruptible)

void setup()
{
  Serial.begin(9600);
  pinMode(6, INPUT_PULLUP);
  pinMode(7, OUTPUT);
  
  pinMode(8, INPUT_PULLUP);
  pinMode(9, OUTPUT);
  
  pinMode(10, INPUT_PULLUP);
  codeur2.setDirection(false); // le codeur 2 est monté à l'envers

}

boolean bouton1fmt = false;
boolean bouton1fdcd = false;
boolean bouton1 = false;
boolean bouton1sto = false;

boolean bouton2fmt = false;
boolean bouton2fdcd = false;
boolean bouton2 = false;
boolean bouton2sto = false;

long compteur1 = 0;
long compteurSto1 = 1000;
long compteur2 = 0;
long compteurSto2 = 1000;

float vitesse1 = 0;
void loop()
{
  bouton1 = digitalRead(6);
  bouton1fmt = bouton1 && !bouton1sto;
  bouton1fdcd = !bouton1 && bouton1sto;
  bouton1sto = bouton1;
  digitalWrite(7, bouton1);
  
  bouton2 = digitalRead(8);
  bouton2fmt = bouton2 && !bouton2sto;
  bouton2fdcd = !bouton2 && bouton2sto;
  bouton2sto = bouton2;
  digitalWrite(9, bouton2);
    
  if (bouton1fmt) {
    codeur1.run();
  };
  if (bouton1fdcd) {
    codeur1.stop();
  };
  if (bouton2fmt) {
    codeur2.run();
  };
  if (bouton2fdcd) {
    codeur2.stop();
  };
  if (digitalRead(10)) {
    codeur1.reset();
    codeur2.reset();
  };
  // Le compteur du codeur N°1
  compteur1 = codeur1.val(); // prise de la valeur courante
  vitesse1 = codeur1.speed();
  if (compteur1 != compteurSto1) // affichage si différent de la dernière valeur affichée
  {
    Serial.print("codeur N 1 :");
    Serial.print(compteur1); // la valeur du compteur
    Serial.print(" <");
    Serial.print(vitesse1); // la vitesse calculée
    Serial.println("pulse/s >");
    compteurSto1 = compteur1;
  }
  // Le compteur N°2 qui evolue de manière asynchrone au compteur N°1
  compteur2 = codeur2.val();
  if (compteur2 != compteurSto2)
  {
    Serial.print("codeur N 2 :");
    compteur2 = codeur2.val();
    Serial.println(compteur2);
    compteurSto2 = compteur2;
  }

}

